package main.java.com.djrapitops.plan.data.handling.info;

import java.util.UUID;
import main.java.com.djrapitops.plan.data.UserData;

/**
 * HandlingInfo Class for DeathEvent information.
 *
 * @author Rsl1122
 * @since 3.0.0
 */
public class DeathInfo extends HandlingInfo {

    /**
     * Constructor.
     *
     * @param uuid UUID of the dead player.
     */
    public DeathInfo(UUID uuid) {
        super(uuid, InfoType.DEATH, 0L);
    }

    @Override
    public boolean process(UserData uData) {
        if (!uData.getUuid().equals(uuid)) {
            return false;
        }
        uData.setDeaths(uData.getDeaths() + 1);
        return true;
    }
}
