package main.java.com.djrapitops.plan.data.handling.info;

import java.util.UUID;
import main.java.com.djrapitops.plan.data.UserData;
import main.java.com.djrapitops.plan.data.handling.KillHandling;
import org.bukkit.entity.LivingEntity;

/**
 * HandlingInfo Class for DeathEvent information when the dead entity is a
 * player.
 *
 * @author Rsl1122
 * @since 3.0.0
 */
public class KillInfo extends HandlingInfo {

    private LivingEntity dead;
    private String weaponName;

    /**
     * Constructor.
     *
     * @param uuid UUID of the killer.
     * @param time Epoch ms the event occurred.
     * @param dead Dead entity (Mob or Player)
     * @param weaponName Weapon used.
     */
    public KillInfo(UUID uuid, long time, LivingEntity dead, String weaponName) {
        super(uuid, InfoType.KILL, time);
        this.dead = dead;
        this.weaponName = weaponName;
    }

    @Override
    public boolean process(UserData uData) {
        if (!uData.getUuid().equals(uuid)) {
            return false;
        }
        KillHandling.processKillInfo(uData, time, dead, weaponName);
        return true;
    }
}
