# ![Player Analytics](https://puu.sh/t8vin.png)

Player Analytics is a Bukkit plugin that gathers data about player activity & displays that data on an internal webserver.
Originally the plugin only displayed data of other plugins, but now it gathers it's own data, while displaying data from various other plugins.
### Links
- [Spigot, Resource page](https://www.spigotmc.org/resources/plan-player-analytics.32536/)
- [Issues & Suggestions](https://github.com/Rsl1122/Plan-PlayerAnalytics/issues)
- [Licence](https://github.com/Rsl1122/Plan-PlayerAnalytics/blob/master/Plan/src/main/resources/licence.yml)

## Documentation
- [Javadocs](https://rsl1122.github.io/Plan-PlayerAnalytics/) (~50% complete, documented packages from plan to plan.database)
- [API](documentation/API.md)
- [Dependencies](documentation/Dependencies.md)
- Data, Collection & Visualisation
  - [Gathering the data & Data cache](documentation/DataGathering.md)
  - [Stored data & data format](documentation/StoredData.md)
  - Analysis
  - Visualization
- Guides
  - [Configuration](documentation/Configuration.md)
  - [Commands & Permissions](documentation/CommandsAndPermissions.md)
  - [Localization](documentation/Localization.md)
  - [Html Customization](documentation/HtmlCustomization.md)
  - [Manage Command Guide](documentation/ManageCommandGuide.md)
- Used libraries
  - [Chart.js](http://www.chartjs.org/docs/) | [Licence](http://www.chartjs.org/docs/#notes-license)
  - [Plotly.js](https://plot.ly/javascript/) | [Licence](https://github.com/plotly/plotly.js/blob/master/LICENSE)
  - [Font Awesome Icons](http://fontawesome.io/icons/) | [Licence](https://opensource.org/licenses/mit-license.html)
  - [Sortable Tables](https://kryogenix.org/code/browser/sorttable/) | [Licence](https://kryogenix.org/code/browser/licence.html)
